using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using C1.Win.C1Input;

namespace C1CustomDropDown
{
	/// <summary>
	/// Summary description for CategoryDropDown.
	/// </summary>
	public class CategoryDropDown : C1.Win.C1Input.DropDownForm
	{
		private System.Windows.Forms.ListView listView1;
		private System.Windows.Forms.ImageList imageList1;
		private System.ComponentModel.IContainer components;

		public CategoryDropDown()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(CategoryDropDown));
			this.listView1 = new System.Windows.Forms.ListView();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.SuspendLayout();
			// 
			// listView1
			// 
			this.listView1.Activation = System.Windows.Forms.ItemActivation.OneClick;
			this.listView1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.listView1.HideSelection = false;
			this.listView1.LargeImageList = this.imageList1;
			this.listView1.Location = new System.Drawing.Point(0, 0);
			this.listView1.Name = "listView1";
			this.listView1.Size = new System.Drawing.Size(360, 152);
			this.listView1.TabIndex = 0;
			this.listView1.Click += new System.EventHandler(this.listView1_Click);
			// 
			// imageList1
			// 
			this.imageList1.ColorDepth = System.Windows.Forms.ColorDepth.Depth32Bit;
			this.imageList1.ImageSize = new System.Drawing.Size(32, 32);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// CategoryDropDown
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.ClientSize = new System.Drawing.Size(360, 152);
			this.Controls.Add(this.listView1);
			this.FocusControl = this.listView1;
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Name = "CategoryDropDown";
			this.Options = C1.Win.C1Input.DropDownFormOptionsFlags.Focusable;
			this.Load += new System.EventHandler(this.CategoryDropDown_Load);
			this.VisibleChanged += new System.EventHandler(this.CategoryDropDown_VisibleChanged);
			this.PostChanges += new System.EventHandler(this.CategoryDropDown_PostChanges);
			this.ResumeLayout(false);

		}
		#endregion

		// Load categories into the ListView control
		private void CategoryDropDown_Load(object sender, System.EventArgs e)
		{
			Form1 f1 = this.Owner as Form1;
			CategoriesDataSet ds = f1.categoriesDataSet;

			for (int i = 0; i < ds.Categories.Count; i++)
			{
				// The ImageList order matches the dataset order
				listView1.Items.Add(ds.Categories[i].CategoryName, i);
			}
		}

		private void CategoryDropDown_PostChanges(object sender, System.EventArgs e)
		{
			// Set the text of the parent control according to the ListView selection
			this.OwnerControl.Text = listView1.SelectedItems[0].Text;
		}

		private void CategoryDropDown_VisibleChanged(object sender, System.EventArgs e)
		{
			// Do nothing if the dropdown is being closed
			if (!this.Visible)
				return;

			listView1.SelectedItems.Clear();

			for (int i = 0; i < listView1.Items.Count; i++)
			{
				ListViewItem lvi = listView1.Items[i];

				// Select the item that matches the text of the parent control
				if (lvi.Text == this.OwnerControl.Text)
				{
					lvi.Selected = true;
					listView1.EnsureVisible(i);
					return;
				}
			}
		}

		private void listView1_Click(object sender, System.EventArgs e)
		{
			// Close the dropdown when the user selects an item by clicking it
			this.OwnerControl.CloseDropDown(true);
		}
	}
}
